<?php

declare(strict_types=1);

namespace Dedi\SyliusSettingsPlugin\DependencyInjection\Compiler;

use Dedi\SyliusSettingsPlugin\DependencyInjection\Configuration;
use Symfony\Component\Config\Definition\Processor;
use Symfony\Component\DependencyInjection\Compiler\CompilerPassInterface;
use Symfony\Component\DependencyInjection\ContainerBuilder;

class CanConfigurePluginsVoterPass implements CompilerPassInterface
{
    public function process(ContainerBuilder $container)
    {
        $processor = new Processor();
        $configuration = $processor->processConfiguration(new Configuration(), $container->getExtensionConfig('dedi_sylius_settings'));

        /** @var array $allowedRoles */
        $allowedRoles = $configuration['roles'];

        $definition = $container->findDefinition('dedi.sylius_settings.voter.can_configure_plugins');
        $definition->setArgument('$allowedRoles', $allowedRoles);
    }
}
